#!/bin/bash
#
# Parse the .csv file for loading into a PostgreSQL database
#
FILE=20080801-occs.csv
#
# 1. Start with the second record since the first is field titles
# 2. Remove the 9 + signs that occur in the abund_value field
# 3. Turn all double double quotes into ~ (since ~ does not occur in the file)
# 4. Search for commas within double quoted fields and replace with + (since +
#    does not occur in the file)
#    (Note: this method has the side effect of adding a double quote at the
#     end of every record, but we're getting rid of those pesky double quotes
#     in the next step anyway.)
# 5. Blow away all double quotes
# 6. Replace all comma delimiters with the new vertical bar delimiter (don't
#    worry, vertical bar is not already used in the file)
# 7. Turn plus signs back into commas
# 8. Remove tildes
# 9. Remove single quotes
# 10. Turn various non ASCII characters into their nearest ASCII counterparts
tail -n+2 ${FILE} | sed 's/+//g;s/,</,/g;s/,>/,/g' |sed 's/""/~/g' | awk -F'"' '{for (i = 1; i <= NF; i++) { if (i%2) { printf "%s\"", $i; } else { string = $i; gsub(",", "+", string); printf "%s\"", string; } } printf "\n";}' | sed 's/"//g' | sed 's/,/|/g' | sed 's/+/,/g' | sed 's/~//g' | sed 's/\x27//g' | sed 's/ã/a/g;s/á/a/g;s/à/a/g;s/é/e/g;s/è/e/g;s/í/i/g;s/ñ/n/g;s/ó/o/g;s/ö/o/g;s/õ/o/g;s/ú/u/g;s/ü/u/g;s/°/degrees/g;s/º/degrees/g;s/?),/,/g;s/?),/,/g;s/0),/,/g;s/1),/,/g;s/2),/,/g;s/3),/,/g;s/4),/,/g;s/5),/,/g;s/6),/,/g;s/7),/,/g;s/8),/,/g;s/9),/,/g;s/,p (/,/g;s/10-25/17.5/g;s/1-10/5.5/g;s/1-2/1.5/g;s/25-50/37.5/g ;s/2-9/5.5/g;s/3-8/5.5/g;s/50-75/67.5/g;s/75-100/87.5/g' | tr '\366' o
