;
pro count_map
;
;Read in data
openr,1,'data/mdiv_patch.dat'
data=dblarr(17,83213)
readf,1,data
close,1

openr,1,'data/gnames.dat'
taxa=strarr(1,83213)
readf,1,taxa
close,1
;
; the total number of degrees
nlon=360L
nlat=180L
;
;set_plot,'z'
set_plot,'ps'
loadct,27
tvlct,RedTab,GreenTab,BlueTab,/get
RedTab(1)=0
GreenTab(1)=0
BlueTab(1)=0
tvlct,RedTab,GreenTab,BlueTab
;device,set_font='Helvetica',/tt_font,set_character_size=[8,12],set_graphics_function=3L,set_resolution=[400,400],z_buffering=0
;
lat=data[ 1,* ]
lon=data[ 2,* ]
names=taxa[ 0,* ]
;
x=dindgen(nlon)-179.5
y=dindgen(nlat)-89.5
tc=lonarr(nlon,nlat)
;;; define pointer tctmp that will point to a string vector
;;; declare and allocate 2d array for depositional habitats
;hab40=lonarr(nlon,nlat)
for mlon=0,nlon-1 do begin
   for mlat=0,nlat-1 do begin
;         print,x[mlon],y[mlon]
      ttmp = gstring(lon,lat,names,x[mlon],y[mlat])
      ;;;specify clust_num index with variable ctemp avoid syntax problems
      ;;;tc is the number of unique genus/class names
      idx=where(lat ge y[mlat]-0.5 and lat lt y[mlat]+0.5 and lon ge x[mlon]-0.5 and lon lt x[mlon]+0.5,cnt)
      if cnt gt 0 then begin
         tc[mlon,mlat]=n_elements(ttmp)
      endif else begin
         ; If no data in this gridcell, set tc to zero.
         tc[mlon,mlat] = 0
      endelse
   endfor ; mlat
endfor ; mlon
; declare the range of tc to pass to map_legend.
tmin = min(tc[where(tc gt 0)])
tmax = max(tc[where(tc gt 0)])
;
tv_data=bytscl(tc,max=tmax,min=tmin,top=251)+3
idx = where(tc eq 0,cnt)
if cnt gt 0 then tv_data[idx] = 255
;
; Alpha Diversity Eastern Asia
device,/encapsulated,/color,bits=24,font_size=12,/helvetica,/bold,file='images/count_map_eas_0-60ma.eps'
map_set,0,0,0,/isotropic,limit=[20,120,70,160],color=1
result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
tv,result,x0,y0
map_continents,/grid,/coasts,color=2,thick=4;,/fill
;map_horizon,color=1
map_legend,tmin,tmax
;
;map=tvrd()
;write_gif,'images/count_map_adiv_eas_'+strtrim(string(i),2)+'-'+strtrim(string(i+(stsz*10)),2)+'.gif',map,RedTab,GreenTab,BlueTab
;
; Alpha Diversity Western Europe
device,/encapsulated,/color,bits=24,font_size=12,/helvetica,/bold,file='images/count_map_eur_0-60ma.eps'
map_set,0,0,0,/isotropic,limit=[30,-10,60,30],color=1
result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
tv,result,x0,y0
map_continents,/grid,/coasts,color=2,thick=4;,/fill
map_legend,tmin,tmax
;
;map=tvrd()
;write_gif,'images/count_map_adiv_eur_'+strtrim(string(i),2)+'-'+strtrim(string(i+(stsz*10)),2)+'.gif',map,RedTab,GreenTab,BlueTab
;
; Alpha Diversity Southeastern US
device,/encapsulated,/color,bits=24,font_size=12,/helvetica,/bold,file='images/count_map_nam_0-60ma.eps'
map_set,0,0,0,/isotropic,limit=[23,-97,45,-72],color=1
result=map_patch(tv_data,x,y,/triangulate,max_value=254,missing=0,xstart=x0,xsize=xs,ystart=y0,ysize=ys)
tv,result,x0,y0
map_continents,/grid,/coasts,color=2,thick=4;,/fill
map_legend,tmin,tmax
;
;map=tvrd()
;write_gif,'images/count_map_adiv_us_'+strtrim(string(i),2)+'-'+strtrim(string(i+(stsz*10)),2)+'.gif',map,RedTab,GreenTab,BlueTab
;
return
end
